/*******************************************************************************
 *  Copyright 2018 Centre for Development of Advanced Computing(C-DAC), Pune
 *  
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *  
 *   http://www.apache.org/licenses/LICENSE-2.0
 *  
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *******************************************************************************/
package cdac.medinfo.sdk.dcm30_04.templates.cid;


import cdac.medinfo.sdk.dcm30_04.templates.enums.EnumCodingSchemeDesignator;
import cdac.medinfo.sdk.dcm30_04.templates.enums.cm.EnumCM_CardiacUltrasoundTricuspidValve;
import cdac.medinfo.sdk.dcm30_04.templates.enums.cm.EnumCM_SourceOfProjectionXRayDoseInformation;
import cdac.medinfo.sdk.dcm30_04.templates.enums.cv.EnumCV_SourceOfProjectionXRayDoseInformation;
import cdac.medinfo.sdk.dcm30_04.templates.dicomsnomedmap.EnumRadiologySNOMEDMap;

/**
 * This class represents SourceOfProjectionX-RayDoseInformation CID10020
 */
public class SourceOfProjectionXRayDoseInformation_CID10020 {

	/**
	 * The Code Value for template.
	 */
	private String strCodeValue = null;

	/**
	 * The Code Meaning for template.
	 */
	private String strCodeMeaning = null;

	/**
	 * The Coding Scheme Designator for template.
	 */
	private String strCodingSchemeDesignator;

	/**
	 * The SNOMED CT ID for template.
	 */
	private String strSNOMEDCTID = null;
	/**
	 * Instantiates a new SourceOfProjectionXRayDoseInformation_CID10020 Template 
	 */
	public SourceOfProjectionXRayDoseInformation_CID10020()
	{

	}

	/**
	 * Retrieves the value for Code Meaning.
	 * @return String value for Code Meaning.
	 */
	public String getCodeMeaning()
	{
		return strCodeMeaning;
	}

	/**
	 * Retrieves the value for Code Value.
	 * @return String value for Code Value.
	 */
	public String getCodeValue() 
	{
		return strCodeValue;
	}

	/**
	 * Retrieves the value for Coding Scheme Designator.
	 * @return String value for Coding Scheme Designator.
	 */
	public String getCodingSchemeDesignator() 
	{
		return strCodingSchemeDesignator;
	}
	
	/**
	 * Retrieves the value for SNOMED-CT ID.
	 * @return String value for SNOMED-CT ID.
	 */
	public String getSNOMEDCTID() 
	{
		return strSNOMEDCTID;
	}
	/**
	 * Sets the Code Value according to Code Meaning.
	 * @param enumSourceOfProjectionX-RayDoseInformation Object of EnumCM_SourceOfProjectionX-RayDoseInformation represents Code Meaning.
	 */
	private void setCodeValue(EnumCM_SourceOfProjectionXRayDoseInformation enumSourceOfProjectionXRayDoseInformation)
	{
		switch(enumSourceOfProjectionXRayDoseInformation) 
		{
		case AUTOMATED_DATA_COLLECTION: this.strCodeValue =EnumCV_SourceOfProjectionXRayDoseInformation.AUTOMATED_DATA_COLLECTION_113856.getValue(); break;
		case MANUAL_ENTRY: this.strCodeValue =EnumCV_SourceOfProjectionXRayDoseInformation.MANUAL_ENTRY_113857.getValue(); break;
		case MPPS_CONTENT: this.strCodeValue =EnumCV_SourceOfProjectionXRayDoseInformation.MPPS_CONTENT_113858.getValue(); break;
		case DOSIMETER: this.strCodeValue =EnumCV_SourceOfProjectionXRayDoseInformation.DOSIMETER_A_2C090.getValue(); break;
		case COPIED_FROM_IMAGE_ATTRIBUTES: this.strCodeValue =EnumCV_SourceOfProjectionXRayDoseInformation.COPIED_FROM_IMAGE_ATTRIBUTES_113866.getValue(); break;
		case COMPUTED_FROM_IMAGE_ATTRIBUTES: this.strCodeValue =EnumCV_SourceOfProjectionXRayDoseInformation.COMPUTED_FROM_IMAGE_ATTRIBUTES_113867.getValue(); break;
		case DERIVED_FROM_HUMAN_READABLE_REPORTS: this.strCodeValue =EnumCV_SourceOfProjectionXRayDoseInformation.DERIVED_FROM_HUMAN_READABLE_REPORTS_113868.getValue(); break;
		case SYSTEM_CALCULATED: this.strCodeValue =EnumCV_SourceOfProjectionXRayDoseInformation.SYSTEM_CALCULATED_113940.getValue(); break;
		}
	}

	/**
	 * Sets the SNOMED-CT ID.
	 * @param enumSourceOfProjectionX-RayDoseInformation Object of EnumCM_SourceOfProjectionX-RayDoseInformation represents Code Meaning.
	 */
	private void setSNOMEDCTID(EnumCM_SourceOfProjectionXRayDoseInformation enumSourceOfProjectionXRayDoseInformation)
	{
		switch(enumSourceOfProjectionXRayDoseInformation)
		{
		case DOSIMETER : this.strSNOMEDCTID =EnumRadiologySNOMEDMap.DOSIMETER.getSNOMEDCTID(); break;
		}
	}

	/**
	 * Sets the value for SourceOfProjectionX-RayDoseInformation
	 * @param enumSourceOfProjectionX-RayDoseInformation Object of EnumCM_SourceOfProjectionX-RayDoseInformation.
	 */
	public void setSourceOfProjectionXRayDoseInformation(EnumCM_SourceOfProjectionXRayDoseInformation enumSourceOfProjectionXRayDoseInformation)
	{
		/**
		 * Retrieves the value for CodingSchemeDesignator, CodingSchemeVersion and Code Meaning and 
		 * sets the Code Value according to Code Meaning.
		 */
		this.strCodeMeaning = enumSourceOfProjectionXRayDoseInformation.getValue();
		if(enumSourceOfProjectionXRayDoseInformation.getValue().equalsIgnoreCase(EnumCM_SourceOfProjectionXRayDoseInformation.DOSIMETER.getValue()))
		{
			this.strCodingSchemeDesignator = EnumCodingSchemeDesignator.SRT.getValue();
		}
		else
		{
			this.strCodingSchemeDesignator = EnumCodingSchemeDesignator.DCM.getValue();
		}
		
		/**
		 * set code Value
		 */
		setCodeValue(enumSourceOfProjectionXRayDoseInformation);

		/**
		 * set SNOMED-CT ID
		 */
		setSNOMEDCTID(enumSourceOfProjectionXRayDoseInformation);
	}
}
